//popup modus => geht auch inline
$.fn.editable.defaults.mode = 'popup';

//falls der focus aus einem  Element liegt, mach es (falls es noch nicht ist) editierbar
$('#WildcardsTable a').click(function(event){
    if(!$(this).hasClass("editable"))
    {
        // löscht StyleClasse fake Empty
        $(this).removeClass("custom-Empty-Fake");

        //fang den Sonderfall Empty ab (dh eintrag wurde leer erstellt)
        content = $(this).text();   
        if(content == "Empty")
        {   
            $(this).text("");
        }

        //mach es editierbar
        $(this).editable({
            type: 'textarea',
            rows: 4,
            send: 'always',
            ajaxOptions: {
                type: 'post'
            },
            url: window.location.pathname + '?page=wildcards&ajaxout=1',
            validate: function(value) {
                if($(this).attr("data-name") == "wildcard" && value == "")
                {
                    return wildcards_dialog_failed_ajax_empty;
                }
            },
            success: function(response) {
                if($(this).attr("data-name") == "wildcard" && response == "false")
                {
                    return wildcards_dialog_failed_ajax_dublicate;
                }
            }
        });

        //set event.preventDefault()
        event.preventDefault();
        //trigger
        $(this).trigger( "click" );
    }
});


/* #################### SUCHE #################### */
    //Bei jeder Tastatureingabe:
     $("#search").keyup(function () {
        //Wert der Eingabe
        var val = $(this).val();
        //no result
        var noResult = true;
        //Alle Zeilen durchlaufen:
        $('.wildcard_content_tr').each(function() {
            //den primary key bekommen durch attributsabfrge
            var pk = $(this).attr("data-pk");
            //auf default alle hidden
            $(this).hide();
            //boolean variable ob in einer Zeile ein Treffer gefunden wurde
            var shouldishow = false;

            //### Enabled
            //Alle Wildcards einer Zeile durchlaufen:
            $(this).find('a[data-pk]').each (function() {
                //Den Wert der Wildcard
                eleVal = $(this).text();
                //val und eleVal vorbereiten (dh alles in kleinbuchstaben):
                var val_low = val.toLowerCase();
                var eleVal_low = eleVal.toLowerCase();
                //Vergleichen ob der eingegebenene Wert (val) in der Wildcard drin vor kommt (eleVal)
                if(eleVal_low.match(val_low))
                {
                    //Ab hier: TREFFER!
                    //setze boolean variable zum Anzeigen auf true;
                    shouldishow = true;
                    //und beende die each itteration
                    return true;
                }
            }); // Ende alle Wildcards einer Zeile

            //### DISABLED
            //Alle Wildcards einer Zeile durchlaufen:
            $(this).find('label[data-pk]').each (function() {
                //Den Wert der Wildcard
                eleVal = $(this).text();
                //val und eleVal vorbereiten (dh alles in kleinbuchstaben):
                var val_low = val.toLowerCase();
                var eleVal_low = eleVal.toLowerCase();
                //Vergleichen ob der eingegebenene Wert (val) in der Wildcard drin vor kommt (eleVal)
                if(eleVal_low.match(val_low))
                {
                    //Ab hier: TREFFER!
                    //setze boolean variable zum Anzeigen auf true;
                    shouldishow = true;
                    //und beende die each itteration
                    return true;
                }
            }); // Ende alle Wildcards einer Zeile

            //Alle IDs durchlaufen:
            $(this).find('#label_id').each (function() {
                //Den Wert der Wildcard
                eleVal = $(this).text();
                //Vergleichen ob der eingegebenene Wert (val) in der Wildcard drin vor kommt (eleVal)
                if(eleVal.match(val))
                {
                    //Ab hier: TREFFER!
                    //setze boolean variable zum Anzeigen auf true;
                    shouldishow = true;
                    //und beende die each itteration
                    return true;
                }
            }); // Ende alle Wildcards einer Zeile

             //Schlussendliche abfrage, ob boolean wert zum anzeigen true ist:
            if(shouldishow == true)
            {
                $(this).show(); 
                noResult = false;
            }

        }); // Emde alle Zeilen

        if(noResult == true)
        {
            $(".noResult").show();
        }
        else
        {
            $(".noResult").hide();
        }

    }); // Ende Key Up
    
    // Anweisung für de Cancel-Button im Suchfeld!
    $('#search').on('search', function () {
        var val = $(this).val();
        if(val == "")
        {
            $('.wildcard_content_tr').show();
        }
    });

/* #################### ENDE SUCHE #################### */


$(document).ready(function() {

    
    // Ändert die Sichtbarkeit der Spalten
    $('input.HidVisCol').on( 'change', function (e) {
        // Der aktuelle gedrückte clang Wert
        var clang = e.target.value;
        //toogle das Element mit dieser Sprache (Klasse sind alle Elemente einer Spale -> th und td)
        $( ".HidVisColElements_"+clang ).toggle(); 

        //Session dementspechend füllen:
        var SessionString = "";
        $('input.HidVisCol').each(function(){
            //falls checked == true
            if($(this).prop('checked'))
            {   
                //fülle Session String (vgl. wie in der Datenbank)
                SessionString += "#" + $(this).attr("value"); 
            }
        });

        //Sende Post an das Ajax Script
        $.post(window.location.pathname + '?page=wildcards&sessionout=1', {wildcards_Session : SessionString});
    });

        
    //Nur die lösch Funktion erlauben, wenn kein Übersetzer (d.h. Admin)
    if(admin)
    {
        // Hover Funktion zum Einblender der Delete Funktion
        $(".wildcard_content_tr").hover(
            function(){
                //Verstecke ID und zeige Delete
                $(this).find("#label_id").hide();
                $(this).find("#delete_icon").show();
            }, 
            function(){
                //Andersrum
                $(this).find("#delete_icon").hide();
                $(this).find("#label_id").show();
            }
        ); //Ende Ein/Ausblend - Funktion
    }


    // Funktion wenn delete Icon wird gedrückt:
    $(".wildcard_content_tr").find("#delete_icon").click(function(){
        
        var conf = confirm(wildcards_add_dialog_delete_confirm);
        //Falls confirm bestätigt wird:
        if(conf == true){
            //bekommt dem primary key
            var pk = $(this).attr("data-pk"); 
            //delete ajax:
            $.ajax({
                type: "POST",
                url: window.location.pathname + '?page=wildcards&ajaxout=1&pkToDelete=' + pk,
                success: function(result){ 
                    if(result == "true")
                    {
                        //Das gelöschte Element wird mit einer Animation (fadeout) entfernt:
                        $('tr[data-pk=' + pk + ']').fadeOut(300, function(){ 
                            $(this).remove();
                        }); 
                    } else if(result == "false") {
                        //Hinweis geben, schief gelaufen:
                        alert(wildcards_dialog_failed_ajax);
                    }
                }
            });
             
        }
    }); // Ende Delete Funktion

    //Nicht editierbare Links in der Tablle kenzeichnen
    $('.NoEditableLinkConf').editable('option', 'disabled', true);
    $('.NoEditableLinkConf').css('cursor', 'pointer');

});